<template>
  <cr-form scroll-to-error @submit="onSubmit" @failed="onFailed" class="container">
    <nav-tab :nav-list="navBarOptions" ref="navTab" @show="e => (goodActionShow = e)" />
    <detail-header :det="headerInfo" />
    <div class="det-body">
      <card title="保险计划" :option="['查看详情']" @option-click="openIframePupop(4)">
        <cr-radio-btn v-model="formData.amountInsured" :radio-data="planOptions" />
        <compactCellGroup :cell-data="planCellData" :text-bold="true" />
        <plan-tip :tip-list="planTipOptions" />
      </card>
      <div id="det_insure">
        <insure-person-form
          v-model="formData"
          :radio-options="personFormOptions"
          ref="insureForm"
          :detail-type="type"
        />
        <auto-deduct
          v-model="formData.autoRenewPolicy"
          :cell-data="autoCellInfo"
          @cell-click="openIframePupop"
        />
        <protocol-read
          v-model="formData.read"
          :cell-data="noticeCellData"
          @cell-click="openIframePupop"
        />
      </div>
      <card class="intro" id="det_intro">
        <cr-image
          :src="item"
          v-for="(item, index) in introImg"
          :key="index"
          width="100%"
          height="auto"
        />
      </card>
      <cps-case :case-data="caseInfo" />
      <div id="det_process">
        <cps-process :process-data="processDetail" @click="openIframePupop(5)" />
      </div>
      <cps-qa :qa-data="qaInfo" />
    </div>
    <detail-footer :company-info="companyInfo" />
    <copyright />
    <good-action :content="goodActionInfo" v-show="goodActionShow" />
    <popup-with-iframe
      v-model="popupShow"
      :title="pupopData.title"
      :content="pupopData.content"
      :url="pupopData.url"
    >
      <cps-process-detail v-if="currentPupopIndex === 5" :process-data="processDetail" />
      <cps-rate :rate-data="rateInfo" v-if="currentPupopIndex === 6" />
    </popup-with-iframe>
    <go-insure-dialog
      v-model="goInsureState"
      :title="headerInfo.title"
      :pay-data="goodBuyModalInfo"
      @confirm="nextStep"
      @read-protocol="openIframePupop"
    />
  </cr-form>
</template>

<script>
/**
 * @description: 华太轻重疾险 Critical illness insurance
 */
import CrRadioBtn from "@/components/CrRadioBtn";
import Card from "@/components/Card";
import Copyright from "@/components/Copyright";
import GoodAction from "@/components/GoodAction";
import Collapse from "@/components/Collapse";

import DetailHeader from "./modules/DetailHeader";
import DetailFooter from "./modules/DetailFooter";
import CompactCellGroup from "@/components/CompactCellGroup";
import CpsCase from "./modules/CpsCase";
import CpsProcess from "./modules/CpsProcess";
import CpsQa from "./modules/CpsQA";
import PopupWithIframe from "@/components/PopupWithIframe";
import GoInsureDialog from "./modules/GoInsureDialog";
import CpsProcessDetail from "./modules/CpsProcessDetail";
import CpsRate from "./modules/CpsRate";
import PlanTip from "./modules/PlanTip";
import InsurePersonForm from "./modules/InsurePersonForm";
import AutoDeduct from "./modules/AutoDeduct";
import ProtocolRead from "./modules/ProtocolRead";
import NavTab from "./modules/NavTab";
import detailLoginMixin from "./modules/detailLogin.mixin";

import localStorage from "@/service/localStorage";
import Detail from "@/api/detail.huatai.zhongjixian";
import { trail, list } from "@/api/product";
import { isIdNo } from "@/service/validation";

export default {
  name: "GoodsDetail-CII",
  components: {
    DetailHeader,
    DetailFooter,
    CompactCellGroup,
    CrRadioBtn,
    Card,
    // eslint-disable-next-line
    Collapse,
    CpsCase,
    CpsProcess,
    CpsQa,
    Copyright,
    PopupWithIframe,
    GoodAction,
    GoInsureDialog,
    CpsProcessDetail,
    CpsRate,
    PlanTip,
    InsurePersonForm,
    AutoDeduct,
    ProtocolRead,
    NavTab
  },
  mixins: [detailLoginMixin],
  data() {
    return {
      ...Detail,
      goodId: "",
      calTimer: null,
      goodActionInfo: {},
      goodBuyModalInfo: [],
      popupShow: false,
      goodActionShow: false,
      currentPupopIndex: null,
      formData: {
        name: "",
        idNo: "",
        relation: "",
        payType: "1",
        amountInsured: "300000",
        autoRenewPolicy: false,
        read: true
      },
      goInsureState: false
    };
  },
  watch: {
    headerInfo: {
      deep: true,
      immediate: true,
      handler(val) {
        const { price, subPrice } = val;
        this.goodActionInfo = {
          title: price,
          sub: subPrice
        };
        this.goodBuyModalInfo = [
          { title: `${price[2]}保费`, value: `${price[0]}${price[1]}` },
          { title: `${subPrice[2]}保费`, value: `${subPrice[0]}${subPrice[1]}${subPrice[3]}` }
        ];
      }
    },
    formDataCpu: {
      deep: true,
      handler(val, oldVal) {
        if (this.calTimer) {
          clearTimeout(this.calTimer);
        }
        const { idNo, payType, amountInsured, relation, selfIdNo } = val;
        const {
          idNo: oldidNo,
          payType: oldpayType,
          amountInsured: oldamountInsured,
          selfIdNo: oldselfIdNo
        } = oldVal;
        let idNoWho = !relation || relation === "1" ? selfIdNo : idNo;
        let oldidNoWho = !relation || relation === "1" ? oldselfIdNo : oldidNo;
        if (!relation && relation === "1") {
          idNoWho = selfIdNo;
          oldidNoWho = oldselfIdNo;
        } else {
          idNoWho = idNo;
          oldidNoWho = oldidNo;
        }
        if (this.goInsureState) {
          const subFormData = JSON.parse(JSON.stringify(this.formData));
          const {
            userInfoSecId,
            name,
            idNo,
            relation,
            socialSecurity,
            selfSocialSecurity,
            selfName,
            selfIdNo,
            selfPhone,
            selfSecId,
            payType,
            amountInsured,
            autoRenewPolicy
          } = subFormData;
          const subFormDataCache = {
            productNo: this.goodId,
            holderUserInfo: {
              phoneNo: selfPhone,
              userInfoSecId: selfSecId ? selfSecId : null,
              name: selfName,
              idNo: selfIdNo
            },
            productItem: {
              payType,
              amountInsured
            },
            autoRenewPolicy: autoRenewPolicy
          };
          if (relation === "1") {
            subFormDataCache.holderUserInfo.socialSecurity = !!Number(selfSocialSecurity);
            subFormDataCache.holderUserInfo.relation = relation;
          } else {
            subFormDataCache.insuredUserInfo = {
              userInfoSecId: userInfoSecId ? userInfoSecId : undefined,
              name,
              idNo,
              relation,
              socialSecurity: !!Number(socialSecurity)
            };
          }
          sessionStorage.setItem("policyFormData", JSON.stringify(subFormDataCache));
        }
        if (
          idNoWho &&
          idNoWho.indexOf("************") === -1 &&
          !isIdNo(idNoWho) &&
          idNoWho === oldidNoWho &&
          payType === oldpayType &&
          amountInsured === oldamountInsured
        )
          return;
        this.calTimer = setTimeout(() => {
          this.calFee();
        }, 1000);
      }
    }
  },
  computed: {
    pupopData() {
      const { popupArray, currentPupopIndex } = this;
      return popupArray[currentPupopIndex] || {};
    },
    planCellData() {
      const { planCellInfo } = this;
      const { amountInsured } = this.formData;
      return planCellInfo[amountInsured];
    },
    noticeCellData() {
      const { noticeCellInfo } = this;
      const { amountInsured } = this.formData;
      return noticeCellInfo[amountInsured];
    },
    personFormOptions() {
      const { insuredOptions, paywayOptions } = this;
      return {
        insuredOptions,
        paywayOptions
      };
    },
    formDataCpu() {
      return JSON.parse(JSON.stringify(this.formData));
    }
  },
  mounted() {
    this.getDetail();
  },
  methods: {
    openIframePupop(index) {
      if (index === 4) {
        this.$router.push({ path: "/goods/plan", query: { type: this.type } });
        return;
      }
      this.currentPupopIndex = index;
      this.popupShow = true;
    },
    onSubmit() {
      if (localStorage.get("mongoToken")) {
        this.goInsureState = true;
        this.$refs.insureForm.getFamilyList();
      } else {
        const { selfPhone, selfCode } = this.formData;
        this.login(selfPhone, selfCode).then(() => {
          this.goInsureState = true;
          this.$refs.insureForm.getFamilyList();
        });
      }
    },
    onFailed(errorInfo) {
      const { errors } = errorInfo;
      const noMsgArr = [
        "selfName",
        "selfIdNo",
        "selfPhone",
        "selfCode",
        "relativeName",
        "relativeIdNo"
      ];
      setTimeout(() => {
        this.$refs.navTab.showNavBar = false;
      }, 0);
      if (!noMsgArr.includes(errors[0].name)) {
        this.$notify({ type: "warning", message: errors[0].message });
      }
      this.$notify({ type: "warning", message: errors[0].message });
    },
    nextStep() {
      this.$router.push({ path: "/goods/inform" });
    },
    async getDetail() {
      this.goodId = this.$route.query.id;
      const res = await list();
      if (res) {
        res.forEach(item => {
          if (item.productNo === this.goodId) {
            this.headerInfo.price[0] = item.downPayPrice;
            this.headerInfo.subPrice[0] = item.regularPrice;
            this.headerInfo.insuredNum = item.sellCount;
          }
        });
      }
    },
    async calFee() {
      let { price, subPrice } = this.headerInfo;
      const {
        idNo,
        socialSecurity,
        relation,
        selfIdNo,
        payType,
        amountInsured,
        userInfoSecId
      } = this.formData;
      let idNoWho = !relation || relation === "1" ? selfIdNo : idNo;
      if (!idNoWho || !payType) return;
      const _param = {
        productNo: this.goodId,
        productUserInfo: {
          insuredUserInfo: {
            idNo: idNoWho,
            socialSecurity: socialSecurity ? !!Number(socialSecurity) : undefined,
            userInfoSecId: userInfoSecId ? userInfoSecId : undefined
          },
          productItem: {
            payType: payType || undefined,
            amountInsured
          }
        }
      };

      const res = await trail(_param);
      if (res) {
        price[2] = payType === "2" ? "" : "首月";
        price[0] = res.downPayPrice;
        subPrice[1] = "元/月";
        subPrice[0] = payType === "2" ? "" : res.regularPrice;
        this.goodActionInfo = {
          title: price,
          sub: subPrice[0] ? subPrice : ""
        };
        this.goodBuyModalInfo = [
          { title: `${price[2]}保费`, value: `${price[0]}${price[1]}` },
          {
            title: `${subPrice[2]}保费`,
            value: subPrice[0] ? `${subPrice[0]}${subPrice[1]}${subPrice[3]}` : ""
          }
        ];
      }
    }
  }
};
</script>
<style lang="less" src="./index.less" scoped></style>
